// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
)

// ItemMetaCreate is the builder for creating a ItemMeta entity.
type ItemMetaCreate struct {
	config
	mutation *ItemMetaMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetKey sets the "key" field.
func (imc *ItemMetaCreate) SetKey(s string) *ItemMetaCreate {
	imc.mutation.SetKey(s)
	return imc
}

// SetValue sets the "value" field.
func (imc *ItemMetaCreate) SetValue(s string) *ItemMetaCreate {
	imc.mutation.SetValue(s)
	return imc
}

// SetCreatedAt sets the "created_at" field.
func (imc *ItemMetaCreate) SetCreatedAt(t time.Time) *ItemMetaCreate {
	imc.mutation.SetCreatedAt(t)
	return imc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (imc *ItemMetaCreate) SetNillableCreatedAt(t *time.Time) *ItemMetaCreate {
	if t != nil {
		imc.SetCreatedAt(*t)
	}
	return imc
}

// SetUpdatedAt sets the "updated_at" field.
func (imc *ItemMetaCreate) SetUpdatedAt(t time.Time) *ItemMetaCreate {
	imc.mutation.SetUpdatedAt(t)
	return imc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (imc *ItemMetaCreate) SetNillableUpdatedAt(t *time.Time) *ItemMetaCreate {
	if t != nil {
		imc.SetUpdatedAt(*t)
	}
	return imc
}

// SetItemID sets the "item_id" field.
func (imc *ItemMetaCreate) SetItemID(u uuid.UUID) *ItemMetaCreate {
	imc.mutation.SetItemID(u)
	return imc
}

// SetMetafilterID sets the "metafilter_id" field.
func (imc *ItemMetaCreate) SetMetafilterID(u uuid.UUID) *ItemMetaCreate {
	imc.mutation.SetMetafilterID(u)
	return imc
}

// SetID sets the "id" field.
func (imc *ItemMetaCreate) SetID(u uuid.UUID) *ItemMetaCreate {
	imc.mutation.SetID(u)
	return imc
}

// SetNillableID sets the "id" field if the given value is not nil.
func (imc *ItemMetaCreate) SetNillableID(u *uuid.UUID) *ItemMetaCreate {
	if u != nil {
		imc.SetID(*u)
	}
	return imc
}

// SetItem sets the "item" edge to the Item entity.
func (imc *ItemMetaCreate) SetItem(i *Item) *ItemMetaCreate {
	return imc.SetItemID(i.ID)
}

// Mutation returns the ItemMetaMutation object of the builder.
func (imc *ItemMetaCreate) Mutation() *ItemMetaMutation {
	return imc.mutation
}

// Save creates the ItemMeta in the database.
func (imc *ItemMetaCreate) Save(ctx context.Context) (*ItemMeta, error) {
	var (
		err  error
		node *ItemMeta
	)
	imc.defaults()
	if len(imc.hooks) == 0 {
		if err = imc.check(); err != nil {
			return nil, err
		}
		node, err = imc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMetaMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = imc.check(); err != nil {
				return nil, err
			}
			imc.mutation = mutation
			if node, err = imc.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(imc.hooks) - 1; i >= 0; i-- {
			if imc.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = imc.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, imc.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*ItemMeta)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from ItemMetaMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (imc *ItemMetaCreate) SaveX(ctx context.Context) *ItemMeta {
	v, err := imc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (imc *ItemMetaCreate) Exec(ctx context.Context) error {
	_, err := imc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (imc *ItemMetaCreate) ExecX(ctx context.Context) {
	if err := imc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (imc *ItemMetaCreate) defaults() {
	if _, ok := imc.mutation.CreatedAt(); !ok {
		v := itemmeta.DefaultCreatedAt()
		imc.mutation.SetCreatedAt(v)
	}
	if _, ok := imc.mutation.UpdatedAt(); !ok {
		v := itemmeta.DefaultUpdatedAt()
		imc.mutation.SetUpdatedAt(v)
	}
	if _, ok := imc.mutation.ID(); !ok {
		v := itemmeta.DefaultID()
		imc.mutation.SetID(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (imc *ItemMetaCreate) check() error {
	if _, ok := imc.mutation.Key(); !ok {
		return &ValidationError{Name: "key", err: errors.New(`ent: missing required field "ItemMeta.key"`)}
	}
	if _, ok := imc.mutation.Value(); !ok {
		return &ValidationError{Name: "value", err: errors.New(`ent: missing required field "ItemMeta.value"`)}
	}
	if _, ok := imc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "ItemMeta.created_at"`)}
	}
	if _, ok := imc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "ItemMeta.updated_at"`)}
	}
	if _, ok := imc.mutation.ItemID(); !ok {
		return &ValidationError{Name: "item_id", err: errors.New(`ent: missing required field "ItemMeta.item_id"`)}
	}
	if _, ok := imc.mutation.MetafilterID(); !ok {
		return &ValidationError{Name: "metafilter_id", err: errors.New(`ent: missing required field "ItemMeta.metafilter_id"`)}
	}
	if _, ok := imc.mutation.ItemID(); !ok {
		return &ValidationError{Name: "item", err: errors.New(`ent: missing required edge "ItemMeta.item"`)}
	}
	return nil
}

func (imc *ItemMetaCreate) sqlSave(ctx context.Context) (*ItemMeta, error) {
	_node, _spec := imc.createSpec()
	if err := sqlgraph.CreateNode(ctx, imc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != nil {
		if id, ok := _spec.ID.Value.(*uuid.UUID); ok {
			_node.ID = *id
		} else if err := _node.ID.Scan(_spec.ID.Value); err != nil {
			return nil, err
		}
	}
	return _node, nil
}

func (imc *ItemMetaCreate) createSpec() (*ItemMeta, *sqlgraph.CreateSpec) {
	var (
		_node = &ItemMeta{config: imc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: itemmeta.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: itemmeta.FieldID,
			},
		}
	)
	_spec.OnConflict = imc.conflict
	if id, ok := imc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = &id
	}
	if value, ok := imc.mutation.Key(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldKey,
		})
		_node.Key = value
	}
	if value, ok := imc.mutation.Value(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldValue,
		})
		_node.Value = value
	}
	if value, ok := imc.mutation.CreatedAt(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldCreatedAt,
		})
		_node.CreatedAt = value
	}
	if value, ok := imc.mutation.UpdatedAt(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldUpdatedAt,
		})
		_node.UpdatedAt = value
	}
	if value, ok := imc.mutation.MetafilterID(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeUUID,
			Value:  value,
			Column: itemmeta.FieldMetafilterID,
		})
		_node.MetafilterID = value
	}
	if nodes := imc.mutation.ItemIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   itemmeta.ItemTable,
			Columns: []string{itemmeta.ItemColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: item.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.ItemID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.ItemMeta.Create().
//		SetKey(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.ItemMetaUpsert) {
//			SetKey(v+v).
//		}).
//		Exec(ctx)
func (imc *ItemMetaCreate) OnConflict(opts ...sql.ConflictOption) *ItemMetaUpsertOne {
	imc.conflict = opts
	return &ItemMetaUpsertOne{
		create: imc,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (imc *ItemMetaCreate) OnConflictColumns(columns ...string) *ItemMetaUpsertOne {
	imc.conflict = append(imc.conflict, sql.ConflictColumns(columns...))
	return &ItemMetaUpsertOne{
		create: imc,
	}
}

type (
	// ItemMetaUpsertOne is the builder for "upsert"-ing
	//  one ItemMeta node.
	ItemMetaUpsertOne struct {
		create *ItemMetaCreate
	}

	// ItemMetaUpsert is the "OnConflict" setter.
	ItemMetaUpsert struct {
		*sql.UpdateSet
	}
)

// SetKey sets the "key" field.
func (u *ItemMetaUpsert) SetKey(v string) *ItemMetaUpsert {
	u.Set(itemmeta.FieldKey, v)
	return u
}

// UpdateKey sets the "key" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateKey() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldKey)
	return u
}

// SetValue sets the "value" field.
func (u *ItemMetaUpsert) SetValue(v string) *ItemMetaUpsert {
	u.Set(itemmeta.FieldValue, v)
	return u
}

// UpdateValue sets the "value" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateValue() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldValue)
	return u
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemMetaUpsert) SetCreatedAt(v time.Time) *ItemMetaUpsert {
	u.Set(itemmeta.FieldCreatedAt, v)
	return u
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateCreatedAt() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldCreatedAt)
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemMetaUpsert) SetUpdatedAt(v time.Time) *ItemMetaUpsert {
	u.Set(itemmeta.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateUpdatedAt() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldUpdatedAt)
	return u
}

// SetItemID sets the "item_id" field.
func (u *ItemMetaUpsert) SetItemID(v uuid.UUID) *ItemMetaUpsert {
	u.Set(itemmeta.FieldItemID, v)
	return u
}

// UpdateItemID sets the "item_id" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateItemID() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldItemID)
	return u
}

// SetMetafilterID sets the "metafilter_id" field.
func (u *ItemMetaUpsert) SetMetafilterID(v uuid.UUID) *ItemMetaUpsert {
	u.Set(itemmeta.FieldMetafilterID, v)
	return u
}

// UpdateMetafilterID sets the "metafilter_id" field to the value that was provided on create.
func (u *ItemMetaUpsert) UpdateMetafilterID() *ItemMetaUpsert {
	u.SetExcluded(itemmeta.FieldMetafilterID)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(itemmeta.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *ItemMetaUpsertOne) UpdateNewValues() *ItemMetaUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(itemmeta.FieldID)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *ItemMetaUpsertOne) Ignore() *ItemMetaUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *ItemMetaUpsertOne) DoNothing() *ItemMetaUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the ItemMetaCreate.OnConflict
// documentation for more info.
func (u *ItemMetaUpsertOne) Update(set func(*ItemMetaUpsert)) *ItemMetaUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&ItemMetaUpsert{UpdateSet: update})
	}))
	return u
}

// SetKey sets the "key" field.
func (u *ItemMetaUpsertOne) SetKey(v string) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetKey(v)
	})
}

// UpdateKey sets the "key" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateKey() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateKey()
	})
}

// SetValue sets the "value" field.
func (u *ItemMetaUpsertOne) SetValue(v string) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetValue(v)
	})
}

// UpdateValue sets the "value" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateValue() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateValue()
	})
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemMetaUpsertOne) SetCreatedAt(v time.Time) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetCreatedAt(v)
	})
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateCreatedAt() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateCreatedAt()
	})
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemMetaUpsertOne) SetUpdatedAt(v time.Time) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateUpdatedAt() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetItemID sets the "item_id" field.
func (u *ItemMetaUpsertOne) SetItemID(v uuid.UUID) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetItemID(v)
	})
}

// UpdateItemID sets the "item_id" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateItemID() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateItemID()
	})
}

// SetMetafilterID sets the "metafilter_id" field.
func (u *ItemMetaUpsertOne) SetMetafilterID(v uuid.UUID) *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetMetafilterID(v)
	})
}

// UpdateMetafilterID sets the "metafilter_id" field to the value that was provided on create.
func (u *ItemMetaUpsertOne) UpdateMetafilterID() *ItemMetaUpsertOne {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateMetafilterID()
	})
}

// Exec executes the query.
func (u *ItemMetaUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for ItemMetaCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *ItemMetaUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *ItemMetaUpsertOne) ID(ctx context.Context) (id uuid.UUID, err error) {
	if u.create.driver.Dialect() == dialect.MySQL {
		// In case of "ON CONFLICT", there is no way to get back non-numeric ID
		// fields from the database since MySQL does not support the RETURNING clause.
		return id, errors.New("ent: ItemMetaUpsertOne.ID is not supported by MySQL driver. Use ItemMetaUpsertOne.Exec instead")
	}
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *ItemMetaUpsertOne) IDX(ctx context.Context) uuid.UUID {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// ItemMetaCreateBulk is the builder for creating many ItemMeta entities in bulk.
type ItemMetaCreateBulk struct {
	config
	builders []*ItemMetaCreate
	conflict []sql.ConflictOption
}

// Save creates the ItemMeta entities in the database.
func (imcb *ItemMetaCreateBulk) Save(ctx context.Context) ([]*ItemMeta, error) {
	specs := make([]*sqlgraph.CreateSpec, len(imcb.builders))
	nodes := make([]*ItemMeta, len(imcb.builders))
	mutators := make([]Mutator, len(imcb.builders))
	for i := range imcb.builders {
		func(i int, root context.Context) {
			builder := imcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ItemMetaMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, imcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = imcb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, imcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, imcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (imcb *ItemMetaCreateBulk) SaveX(ctx context.Context) []*ItemMeta {
	v, err := imcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (imcb *ItemMetaCreateBulk) Exec(ctx context.Context) error {
	_, err := imcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (imcb *ItemMetaCreateBulk) ExecX(ctx context.Context) {
	if err := imcb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.ItemMeta.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.ItemMetaUpsert) {
//			SetKey(v+v).
//		}).
//		Exec(ctx)
func (imcb *ItemMetaCreateBulk) OnConflict(opts ...sql.ConflictOption) *ItemMetaUpsertBulk {
	imcb.conflict = opts
	return &ItemMetaUpsertBulk{
		create: imcb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (imcb *ItemMetaCreateBulk) OnConflictColumns(columns ...string) *ItemMetaUpsertBulk {
	imcb.conflict = append(imcb.conflict, sql.ConflictColumns(columns...))
	return &ItemMetaUpsertBulk{
		create: imcb,
	}
}

// ItemMetaUpsertBulk is the builder for "upsert"-ing
// a bulk of ItemMeta nodes.
type ItemMetaUpsertBulk struct {
	create *ItemMetaCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(itemmeta.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *ItemMetaUpsertBulk) UpdateNewValues() *ItemMetaUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(itemmeta.FieldID)
				return
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.ItemMeta.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *ItemMetaUpsertBulk) Ignore() *ItemMetaUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *ItemMetaUpsertBulk) DoNothing() *ItemMetaUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the ItemMetaCreateBulk.OnConflict
// documentation for more info.
func (u *ItemMetaUpsertBulk) Update(set func(*ItemMetaUpsert)) *ItemMetaUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&ItemMetaUpsert{UpdateSet: update})
	}))
	return u
}

// SetKey sets the "key" field.
func (u *ItemMetaUpsertBulk) SetKey(v string) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetKey(v)
	})
}

// UpdateKey sets the "key" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateKey() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateKey()
	})
}

// SetValue sets the "value" field.
func (u *ItemMetaUpsertBulk) SetValue(v string) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetValue(v)
	})
}

// UpdateValue sets the "value" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateValue() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateValue()
	})
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemMetaUpsertBulk) SetCreatedAt(v time.Time) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetCreatedAt(v)
	})
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateCreatedAt() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateCreatedAt()
	})
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemMetaUpsertBulk) SetUpdatedAt(v time.Time) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateUpdatedAt() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateUpdatedAt()
	})
}

// SetItemID sets the "item_id" field.
func (u *ItemMetaUpsertBulk) SetItemID(v uuid.UUID) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetItemID(v)
	})
}

// UpdateItemID sets the "item_id" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateItemID() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateItemID()
	})
}

// SetMetafilterID sets the "metafilter_id" field.
func (u *ItemMetaUpsertBulk) SetMetafilterID(v uuid.UUID) *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.SetMetafilterID(v)
	})
}

// UpdateMetafilterID sets the "metafilter_id" field to the value that was provided on create.
func (u *ItemMetaUpsertBulk) UpdateMetafilterID() *ItemMetaUpsertBulk {
	return u.Update(func(s *ItemMetaUpsert) {
		s.UpdateMetafilterID()
	})
}

// Exec executes the query.
func (u *ItemMetaUpsertBulk) Exec(ctx context.Context) error {
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the ItemMetaCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for ItemMetaCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *ItemMetaUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
